<template>
  <div class="flex flex-col">
    <div class="flex justify-center">
      <div class="text-xl text-white w-[40rem]">
        {{ question_str }}
      </div>
    </div>
    <div class="flex mt-4 items-center justify-center">
      <div class="inline-block">
        <a-input label="Country:" placeholder="country"
          :validators="countryValidators" v-model="country" />
        <a-input label="Amount of members:" placeholder="amount"
          :validators="amoutValidators" v-model="amount" />
        <submit-button value="find" @click="execute" />
      </div>
      <sql-query-text>{{ sql_query }}</sql-query-text>
    </div>
    <div class="flex justify-center">
      <Lodges title="result"/>
    </div>

  </div>
</template>

<script>
import AInput from '@/components/AInput.vue';
import { positiveNumberValidator, emptyValidator } from '@/components/Validators.js'
import SubmitButton from '@/components/SubmitButton.vue';
import TableBase from '@/components/TableBase.vue';
import SimpleSqlQueries from '@/assets/SimpleQueries.json';
import SqlQueryText from '@/components/SqlQueryText.vue';
import { mapMutations } from 'vuex';
import { add_lodges } from '@/components/helpers';
import Lodges from '@/components/Lodges.vue';
import axiosClient from '@/axiosClient';

export default {
  components: {
    AInput,
    SubmitButton,
    TableBase,
    SqlQueryText,
    Lodges
  },
  data() {
    return {
      amoutValidators: [positiveNumberValidator],
      countryValidators: [emptyValidator],
      question_str: SimpleSqlQueries[1].question,
      sql_query: SimpleSqlQueries[1].query,
      amount: undefined,
      country: '',

    }
  },
  methods: {
    ...mapMutations(["clearLodges"]),
    execute() {
      axiosClient.get('simple-query/2', {headers:{k:this.country, n:this.amount}})
      .then((response) => {
        this.clearLodges()
        debugger
        add_lodges(response)
      })
    }
  },
  mounted() {
    this.clearLodges();
  }
}


</script>